<template>
  <div
    class="ob-order-contractor-card"
    :data-qa="dataQa"
    @click="$emit('click')"
  >
    <div class="ob-order-contractor-card__caption">
      {{ caption }}
    </div>

    <div class="ob-order-contractor-card__body">
      <div class="ob-order-contractor-card__title">
        <div class="ob-order-contractor-card__title-dropdown">
          <ObMenuDropdown
            :items="dropdownTabs || []"
            :is-arrow="false"
            :data-qa="dataQa"
          />
        </div>
        <div class="ob-order-contractor-card__title-icon-status">
          <span v-html="statusIcon" />
        </div>
        <div class="ob-order-contractor-card__title-status-block">
          <div
            class="ob-order-contractor-card__title-status-text"
            :style="statusColor"
          >
            {{ inData.status.text }} {{ inData.status.counter }}
          </div>
        </div>
        <div class="ob-order-contractor-card__title-icon">
          <span :class="titleIcon" />
        </div>
        <div class="ob-order-contractor-card__title-text">
          {{ inData.vehicle.name }}
        </div>
      </div>

      <div
        v-if="inData.entities.length==0"
        class="ob-order-contractor-card__searching"
      >
        <div class="ob-order-contractor-card__searching__item">
          {{ inData.status.text }} ...
        </div>
      </div>

      <div
        v-if="inData.entities.length>0"
        class="ob-order-contractor-card__entities"
      >
        <div
          v-for="(item, index) in inData.entities"
          :key="`entity_${index}`"
          class="ob-order-contractor-card__entities__entity"
        >
          <div class="ob-order-contractor-card__entities__entity__title">
            {{ item.title }}
          </div>
          <div class="ob-order-contractor-card__entities__entity__risks">
            <span v-html="riskIcon(item.risk)" />
            <span
              v-if="item.type==1"
              class="ob-order-contractor-card__entities__entity__risks__reg-number"
            >
              <span class="block">{{ item.grzNum }}</span>
              <span class="block">{{ item.grzReg }}</span>
            </span>
            <div
              v-if="item.type==2"
              class="ob-order-contractor-card__entities__entity__fio"
            >
              {{ item.fio }}
            </div>
            <div class="ob-order-contractor-card__entities__entity__description">
              {{ item.info }}
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>

import ObMenuDropdown from '../../obComponents/obMenuDropdown'

export default {
  components: {
    ObMenuDropdown
  },
  props: {
    caption: {
      type: String
    },
    inData: {
      type: Object,
      default: () => {}
    },
    dropdownTabs: {
      type: Array,
      default: () => []
    },
    dataQa: {
      type: String
    }
  },
  computed: {
    isEmpty () {
      return !this.date && !this.time
    },
    titleIcon () {
      return 'icon ' + this.inData.vehicle.icon.name + ' -light-denim'
    },
    statusIcon () {
      return '<span class="icon ' + this.inData.status.icon.name + '" style="color:' + this.inData.status.icon.color + '" />'
    },
    statusColor () {
      return 'color:' + this.inData.status.icon.color
    }
  },
  methods: {
    riskIcon (risk) {
      return risk.icon ? '<span class="icon ' + risk.icon.name + '" />' : ''
    }
  }
}

</script>

<style lang="scss">
@import "../../static/css/mixins";
@import "../../static/css/variables";

.ob-order-contractor-card {
  padding: 15px 15px;
  background-color: $background-white;
  & i {
    color: $cobalt;
  }
  &__caption {
    line-height: 28px;
    font-weight: bold;
    font-size: 20px;
    margin-bottom: 30px;
  }
  &__body {
    background-color: $light-lavender;
    padding: 20px;
    border: 1px solid $obOrderContractorCard-border_color;
    box-shadow: 0px 1px 7px rgba($color-blue-navy-blue, 0.1);
    border-radius: 4px;
  }
  &__title {
    margin-bottom: 20px;
    &:after {
      content: '';
      display: block;
      clear: both;
    }
    &-icon {
      float: left;
      margin-right: 15px;
      max-width: 75px;
      font-size: 26px;
    }
    &-text {
      font-size: 16px;
      line-height: 20px;
      letter-spacing: 0.2px;
      padding-top: 0.2em;
    }
    &-dropdown {
      float: right;
      width: 45px;
      .ob-menu-dropdown-container {
        .wrapper {
          .menu-button {
            height: 30px;
          }
        }
      }
    }
    &-status {
      &-block{
        float: right;
        height: 40px;
        line-height: 30px;
        text-align: right;
        width: 200px;
      }
      &-text {
        display: inline-block;
        vertical-align: middle;
        margin-right: 15px;
        font-size: 12px;
        letter-spacing: 0.4px;

        line-height: 16px;
      }
    }
    &-icon-status {
      float: right;
      width: 25px;
      color: $color-grey-span;
      font-size: 24px;
      margin-right: 10px;
      padding-top: 3px;
    }
  }
  &__searching {
    border: 1px solid $cornflower-craiola;
    box-sizing: border-box;
    border-radius: 3px;
    background: $lavender;
    opacity: 0.5;
    &__item {
      font-size: 16px;
      letter-spacing: 0.2px;
      color: $color-grey-span;
      margin: 20px 12px;
    }
  }
  &__entities {
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;
    &__entity {
      width: 33%;
      background-color: $lavender;
      border: 1px solid $cornflower-craiola;
      border-radius: 3px;
      padding: 10px 12px;
      margin: 3px 0;
      &__title {
        font-size: 12px;
        line-height: 12px;
        letter-spacing: 0.4px;
        color: $gray-slate;
        margin-bottom: 5px;
      }
      &__risks {
        .icon {
          float: left;
          font-size: 20px;
          margin-right: 5px;
        }
        &__reg-number {
          display: inline-block;
          vertical-align: top;
          border: 1px solid $cornflower-craiola;
          border-radius: 3px;
          font-size: 14px;
          line-height: 16px;
          letter-spacing: 0.2px;
          color: $obOrderContractorCard-font_color_reg_number;
          text-transform: lowercase;
          font-variant: small-caps;
          background: $background-white;
          .block {
            padding: 2px 4px;
            display: inline-block;
            vertical-align: top;
            &:last-child {
              border-left: 1px solid $cornflower-craiola;
            }
          }
        }
      }
    &__fio {
        line-height: 22px;
    }
      &__description {
        font-size: 12px;
        line-height: 20px;
        letter-spacing: 0.2px;
        color: $gray-slate;
        margin-top: 7px;
      }
    }
  }

  &.--state-empty {
    padding: 16px 19px 19px;
  }
}

</style>
